/************************************************************************
 *   IRC - Internet Relay Chat, include/msg.h
 *   Copyright (C) 1990 Jarkko Oikarinen and
 *                      University of Oulu, Computing Center
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 1, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef	__msg_include__
#define __msg_include__

/* Unfortunately all the TOC's are characters, so would need separate ones
   for strings... sighs, perhaps one day I'll do that ;) -Donwulff */

#define MSG_PRIVATE  "PRIVMSG"	/* PRIV */
#define TOC_PRIVATE  '\''
#define MSG_WHO      "WHO"	/* WHO  -> WHOC */
#define TOC_WHO      'W'
#define MSG_WHOIS    "WHOIS"	/* WHOI */
#define TOC_WHOIS    'w'
#define MSG_WHOWAS   "WHOWAS"	/* WHOW */
#define TOC_WHOWAS   'b'
#define MSG_USER     "USER"	/* USER */
#define TOC_USER     'u'
#define MSG_NICK     "NICK"	/* NICK */
#define TOC_NICK     'n'
#define MSG_SERVER   "SERVER"	/* SERV */
#define TOC_SERVER   's'
#define MSG_LIST     "LIST"	/* LIST */
#define TOC_LIST     'l'
#define MSG_TOPIC    "TOPIC"	/* TOPI */
#define TOC_TOPIC    't'
#define MSG_INVITE   "INVITE"	/* INVI */
#define TOC_INVITE   'i'
#define MSG_VERSION  "VERSION"	/* VERS */
#define TOC_VERSION  'v'
#define MSG_QUIT     "QUIT"	/* QUIT */
#define TOC_QUIT     'q'
#define MSG_SQUIT    "SQUIT"	/* SQUI */
#define TOC_SQUIT    'S'
#define MSG_KILL     "KILL"	/* KILL */
#define TOC_KILL     'K'
#define MSG_INFO     "INFO"	/* INFO */
#define TOC_INFO     'f'
#define MSG_LINKS    "LINKS"	/* LINK */
#define TOC_LINKS    'L'
#define MSG_SUMMON   "SUMMON"	/* SUMM */
#define TOC_SUMMON   'R'
#define MSG_STATS    "STATS"	/* STAT */
#define TOC_STATS    '%'
#define MSG_USERS    "USERS"	/* USER -> USRS */
#define TOC_USERS    'r'
#define MSG_HELP     "HELP"	/* HELP */
#define TOC_HELP     '?'
#define MSG_ERROR    "ERROR"	/* ERRO */
#define TOC_ERROR    'E'
#define MSG_AWAY     "AWAY"	/* AWAY */
#define TOC_AWAY     'a'
#define MSG_CONNECT  "CONNECT"	/* CONN */
#define TOC_CONNECT  'C'
#define MSG_PING     "PING"	/* PING */
#define TOC_PING     '<'
#define MSG_PONG     "PONG"	/* PONG */
#define TOC_PONG     '>'
#define MSG_OPER     "OPER"	/* OPER */
#define TOC_OPER     'o'
#define MSG_PASS     "PASS"	/* PASS */
#define TOC_PASS     'p'
#define MSG_WALLOPS  "WALLOPS"	/* WALL */
#define TOC_WALLOPS  'V'
#define MSG_TIME     "TIME"	/* TIME */
#define TOC_TIME     'T'
#define MSG_NAMES    "NAMES"	/* NAME */
#define TOC_NAMES    'N'
#define MSG_ADMIN    "ADMIN"	/* ADMI */
#define TOC_ADMIN    'A'
#define MSG_TRACE    "TRACE"	/* TRAC */
#define TOC_TRACE    '='
#define MSG_NOTICE   "NOTICE"	/* NOTI */
#define TOC_NOTICE   '\"'
#define MSG_JOIN     "JOIN"	/* JOIN */
#define TOC_JOIN     '+'
#define MSG_PART     "PART"	/* PART */
#define TOC_PART     '-'
#define MSG_LUSERS   "LUSERS"	/* LUSE */
#define TOC_LUSERS   '#'
#define MSG_MOTD     "MOTD"	/* MOTD */
#define TOC_MOTD     'M'
#define MSG_MODE     "MODE"	/* MODE */
#define TOC_MODE     'm'
#define MSG_KICK     "KICK"	/* KICK */
#define TOC_KICK     'k'
#define MSG_USERHOST "USERHOST"	/* USER -> USRH */
#define TOC_USERHOST 'U'
#define MSG_ISON     "ISON"	/* ISON */
#define TOC_ISON     'I'
#define	MSG_REHASH   "REHASH"	/* REHA */
#define TOC_REHASH   'z'
#define	MSG_RESTART  "RESTART"	/* REST */
#define TOC_RESTART  'Z'
#define	MSG_CLOSE    "CLOSE"	/* CLOS */
#define TOC_CLOSE    'c'
#define	MSG_DIE	     "DIE"
#define TOC_DIE      'X'
#define	MSG_HASH     "HASH"	/* HASH */
#define TOC_HASH     'h'
#define	MSG_DNS      "DNS"	/* DNS  -> DNSS */
#define TOC_DNS      'D'
#define MSG_SILENCE  "SILENCE"  /* SILE */
#define TOC_SILENCE  '!'
#define MSG_AKILL    "AKILL"	/* AKILL */
#define TOC_AKILL    '['
#define MSG_KLINE    "KLINE"	/* KLINE */
#define TOC_KLINE    '('
#define MSG_UNKLINE  "UNKLINE"  /* UNKLINE */
#define TOC_UNKLINE  ')'
#define MSG_RAKILL   "RAKILL"   /* RAKILL */
#define TOC_RAKILL   ']'
#define MSG_GNOTICE  "GNOTICE"  /* GNOTICE */
#define TOC_GNOTICE  'G'
#define MSG_GOPER    "GOPER"    /* GOPER */
#define TOC_GOPER    'H'
#define MSG_GLOBOPS  "GLOBOPS"  /* GLOBOPS */
#define TOC_GLOBOPS  'g'
#define MSG_PROTOCTL "PROTOCTL" /* PROTOCTL */
#define TOC_PROTOCTL 'P'

#define MAXPARA    15 

extern int m_private(), m_topic(), m_join(), m_part(), m_mode();
extern int m_ping(), m_pong(), m_wallops(), m_kick();
extern int m_nick(), m_error(), m_notice();
extern int m_invite(), m_quit(), m_kill();
extern int m_akill(), m_kline(), m_unkline(), m_rakill();
extern int m_gnotice(), m_goper(), m_globops();
extern int m_protoctl();
#ifndef CLIENT_COMPILE
extern int m_motd(), m_who(), m_whois(), m_user(), m_list();
extern int m_server(), m_info(), m_links(), m_summon(), m_stats();
extern int m_users(), m_version(), m_help();
extern int m_squit(), m_away(), m_connect();
extern int m_oper(), m_pass(), m_trace();
extern int m_time(), m_names(), m_admin();
extern int m_lusers(), m_umode(), m_close();
extern int m_motd(), m_whowas(), m_silence();
extern int m_service(), m_userhost(), m_ison();
extern int m_service(), m_servset(), m_servlist(), m_squery();
#if defined(OPER_REHASH) || defined(LOCOP_REHASH)
extern	int	m_rehash();
#endif
#if defined(OPER_RESTART) || defined(LOCOP_RESTART)
extern	int	m_restart();
#endif
#if defined(OPER_DIE) || defined(LOCOP_DIE)
extern	int	m_die();
#endif
extern int m_hash(), m_dns();
#endif /* !CLIENT_COMPILE */

#ifdef MSGTAB
char msgmap[256];
struct Message msgtab[] = {
  { MSG_PRIVATE, m_private,  0, MAXPARA, 1 ,TOC_PRIVATE ,0L },
  { MSG_NICK,    m_nick,     0, MAXPARA, 1 ,TOC_NICK    ,0L },
  { MSG_NOTICE,  m_notice,   0, MAXPARA, 1 ,TOC_NOTICE  ,0L },
  { MSG_JOIN,    m_join,     0, MAXPARA, 1 ,TOC_JOIN    ,0L },
  { MSG_MODE,    m_mode,     0, MAXPARA, 1 ,TOC_MODE    ,0L },
  { MSG_QUIT,    m_quit,     0, MAXPARA, 1 ,TOC_QUIT    ,0L },
  { MSG_PART,    m_part,     0, MAXPARA, 1 ,TOC_PART    ,0L },
  { MSG_TOPIC,   m_topic,    0, MAXPARA, 1 ,TOC_TOPIC   ,0L },
  { MSG_INVITE,  m_invite,   0, MAXPARA, 1 ,TOC_INVITE  ,0L },
  { MSG_KICK,    m_kick,     0, MAXPARA, 1 ,TOC_KICK    ,0L },
  { MSG_WALLOPS, m_wallops,  0, MAXPARA, 1 ,TOC_WALLOPS ,0L },
  { MSG_PING,    m_ping,     0, MAXPARA, 1 ,TOC_PING    ,0L },
  { MSG_PONG,    m_pong,     0, MAXPARA, 1 ,TOC_PONG    ,0L },
  { MSG_ERROR,   m_error,    0, MAXPARA, 1 ,TOC_ERROR   ,0L },
  { MSG_KILL,    m_kill,     0, MAXPARA, 1 ,TOC_KILL    ,0L },
  { MSG_PROTOCTL,m_protoctl, 0, MAXPARA, 1 ,TOC_PROTOCTL,0L },
#ifndef CLIENT_COMPILE
  { MSG_USER,    m_user,     0, MAXPARA, 1 ,TOC_USER    ,0L },
  { MSG_AWAY,    m_away,     0, MAXPARA, 1 ,TOC_AWAY    ,0L },
  { MSG_ISON,    m_ison,     0,       1, 1 ,TOC_ISON    ,0L },
  { MSG_SERVER,  m_server,   0, MAXPARA, 1 ,TOC_SERVER  ,0L },
  { MSG_SQUIT,   m_squit,    0, MAXPARA, 1 ,TOC_SQUIT   ,0L },
  { MSG_WHOIS,   m_whois,    0, MAXPARA, 1 ,TOC_WHOIS   ,0L },
  { MSG_WHO,     m_who,      0, MAXPARA, 1 ,TOC_WHO     ,0L },
  { MSG_WHOWAS,  m_whowas,   0, MAXPARA, 1 ,TOC_WHOWAS  ,0L },
  { MSG_LIST,    m_list,     0, MAXPARA, 1 ,TOC_LIST    ,0L },
  { MSG_NAMES,   m_names,    0, MAXPARA, 1 ,TOC_NAMES   ,0L },
  { MSG_USERHOST,m_userhost, 0,       1, 1 ,TOC_USERHOST,0L },
  { MSG_TRACE,   m_trace,    0, MAXPARA, 1 ,TOC_TRACE   ,0L },
  { MSG_PASS,    m_pass,     0, MAXPARA, 1 ,TOC_PASS    ,0L },
  { MSG_LUSERS,  m_lusers,   0, MAXPARA, 1 ,TOC_LUSERS  ,0L },
  { MSG_TIME,    m_time,     0, MAXPARA, 1 ,TOC_TIME    ,0L },
  { MSG_OPER,    m_oper,     0, MAXPARA, 1 ,TOC_OPER    ,0L },
  { MSG_CONNECT, m_connect,  0, MAXPARA, 1 ,TOC_CONNECT ,0L },
  { MSG_VERSION, m_version,  0, MAXPARA, 1 ,TOC_VERSION ,0L },
  { MSG_STATS,   m_stats,    0, MAXPARA, 1 ,TOC_STATS   ,0L },
  { MSG_LINKS,   m_links,    0, MAXPARA, 1 ,TOC_LINKS   ,0L },
  { MSG_ADMIN,   m_admin,    0, MAXPARA, 1 ,TOC_ADMIN   ,0L },
  { MSG_USERS,   m_users,    0, MAXPARA, 1 ,TOC_USERS   ,0L },
  { MSG_SUMMON,  m_summon,   0, MAXPARA, 1 ,TOC_SUMMON  ,0L },
  { MSG_HELP,    m_help,     0,       1, 1 ,TOC_HELP    ,0L },
  { MSG_INFO,    m_info,     0, MAXPARA, 1 ,TOC_INFO    ,0L },
  { MSG_MOTD,    m_motd,     0, MAXPARA, 1 ,TOC_MOTD    ,0L },
  { MSG_CLOSE,   m_close,    0, MAXPARA, 1 ,TOC_CLOSE   ,0L },
  { MSG_SILENCE, m_silence,  0, MAXPARA, 1 ,TOC_SILENCE ,0L },
  { MSG_AKILL,   m_akill,    0, MAXPARA, 1 ,TOC_AKILL   ,0L },
#ifdef OPER_KLINE
  { MSG_KLINE,   m_kline,    0, MAXPARA, 1 ,TOC_KLINE   ,0L },
  { MSG_UNKLINE, m_unkline,  0, MAXPARA, 1 ,TOC_UNKLINE ,0L },
#endif
  { MSG_RAKILL,  m_rakill,   0, MAXPARA, 1 ,TOC_RAKILL  ,0L },
  { MSG_GNOTICE, m_gnotice,  0, MAXPARA, 1 ,TOC_GNOTICE ,0L },
  { MSG_GOPER,   m_goper,    0, MAXPARA, 1 ,TOC_GOPER   ,0L },
  { MSG_GLOBOPS, m_globops,  0, MAXPARA, 1 ,TOC_GLOBOPS ,0L },
  { MSG_HASH,    m_hash,     0, MAXPARA, 1 ,TOC_HASH    ,0L },
  { MSG_DNS,     m_dns,      0, MAXPARA, 1 ,TOC_DNS     ,0L },
#if defined(OPER_REHASH) || defined(LOCOP_REHASH)
  { MSG_REHASH,  m_rehash,   0, MAXPARA, 1 ,TOC_REHASH  ,0L },
#endif
#if defined(OPER_RESTART) || defined(LOCOP_RESTART)
  { MSG_RESTART, m_restart,  0, MAXPARA, 1 ,TOC_RESTART ,0L },
#endif
#if defined(OPER_DIE) || defined(LOCOP_DIE)
  { MSG_DIE,     m_die,      0, MAXPARA, 1 ,TOC_DIE     ,0L },
#endif
#endif /* !CLIENT_COMPILE */
  { (char *) 0, (int (*)()) 0 , 0, 0, 0, 0L}
};
#else
extern struct Message msgtab[];
extern char msgmap[256];
#endif
#endif /* __msg_include__ */
